/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void CopyCB();
static void Paste0CB();
static void Paste1CB();
static Boolean ConvertProc();
static void LoseProc();
static void GetValueProc();

static Atom xa_filename;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, text, copy, paste0, paste1;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);

    ac = 0;
    toplevel = XtOpenApplication(&app_context, "Selectparam", NULL, 0,
                     &argc, argv, NULL, sessionShellWidgetClass, al, ac);

    ac = 0;
    panel = XmCreateRowColumn(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* ƥΰ */
    ac = 0;
    text = XmCreateText(panel, "text", al, ac);
    XtManageChild(text);

    /* [ԡ] ܥ --> ͭ: 쥯ͭ */
    ac = 0;
    copy = XmCreatePushButton(panel, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, text);
    XtManageChild(copy);

    /* (1) [Хѥ] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste0 = XmCreatePushButton(panel, "paste0", al, ac);
    XtAddCallback(paste0, XmNactivateCallback, Paste0CB, text);
    XtManageChild(paste0);

    /* (2) [ե̾] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste1 = XmCreatePushButton(panel, "paste1", al, ac);
    XtAddCallback(paste1, XmNactivateCallback, Paste1CB, text);
    XtManageChild(paste1);

    /* (3) "_FILENAME" Υȥ */
    xa_filename = XmInternAtom(XtDisplay(toplevel), "_FILENAME", False);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* ͭ: [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;

    /* 쥯ͭ (3ĤΥХåϿ) */
    if (XtOwnSelection(text, XA_PRIMARY,
                       XtLastTimestampProcessed(XtDisplay(text)),
                       ConvertProc, LoseProc, NULL))
        /* ͭǤ顤ƥȤĴɽΤ餻 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* ͭ: 쥯νͭ򼺤äȤ˸ƤӽФ */
static void LoseProc(w, selection)
    Widget w;
    Atom *selection;
{
    /* 쥯νͭԤǤʤʤä顤Ĵɽ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* ׵: [Хѥ] ܥΥХå */
static void Paste0CB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    int which = 0;

    /* (4) 쥯׵˥ѥ᡼ղ (0 Хѥ׵) */
    XtSetSelectionParameters(text, XA_PRIMARY, XA_INTEGER, &which, 1, 32);

    /* 쥯Υǡ׵ (ǡϥХåǼ) */
    XtGetSelectionValue(text, XA_PRIMARY, xa_filename, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* ׵: [ե̾] ܥΥХå */
static void Paste1CB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget text = (Widget)client_data;
    int which = 1;

    /* (5) 쥯׵˥ѥ᡼ղ (1 ϥե̾Τߤ׵) */
    XtSetSelectionParameters(text, XA_PRIMARY, XA_INTEGER, &which, 1, 32);

    /* 쥯Υǡ׵ (ǡϥХåǼ) */
    XtGetSelectionValue(text, XA_PRIMARY, xa_filename, GetValueProc, NULL,
                        XtLastTimestampProcessed(XtDisplay(text)));
}

/* ͭ: 쥯Υǡ׵ᤵ줿Ȥ˸ƤӽФ */
static Boolean ConvertProc(w, selection, target,
                           type_ret, val_ret, len_ret, format_ret)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
{
    char *string;
    Atom param_type;
    XtPointer param_val;
    unsigned long param_len;
    int param_format;

    /* žǡѰդ֤ */
    if (*selection == XA_PRIMARY && *target == xa_filename) {
        string = XmTextGetString(w);   /* žΤϤ줿ƥ */
        XtGetSelectionParameters(w, XA_PRIMARY, NULL, &param_type,
                                 &param_val, &param_len, &param_format);
        /* (6) ѥ᡼ͤ 1 ʤ顤ե̾ʬФ */
        if (param_type == XA_INTEGER && param_len > 0 && *(int*)param_val == 1) {
            string = strrchr(string, '/');
            string++;
        }
        *val_ret = string;
        *len_ret = strlen(string) + 1; /* Ǹ NULL ɲ */
        *type_ret = XA_STRING;         /* ϱѸΥƥȤΤ߰ */
        *format_ret = 8;               /* ʸΥեޥåȤ 8 */
        return True;   /* žǡνȤ */
    }
    else
        return False;  /* ׵ᤵ줿쥯ȥפ㤦 */
}

/* ׵: 쥯ΥǡäȤ˸ƤӽФ */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    if (*len == 0 || val == NULL) { /* ǡμ˼ */
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    /* äǡƥȡåȤ˥ڡ */
    if (*selection == XA_PRIMARY && *type == XA_STRING)
        XmTextSetString(w, (char *)val);
    else
        XBell(XtDisplay(w), 0);  /* פ㤦ȥ٥ǼԤι */

    XtFree((char *)val);
}
