/***********************************************************************
 *      ΥץץϰʲνҤȴǤ             *
 *                                                                     *
 *          X Window OSF/Motif ġ륭å ץߥ (II)        *
 *            - եåȼ꥽ܸ졦̿ -             *
 *                                                                     *
 *      Copyright 1995,                                          *
 *                                                                     *
 *      ɽȤս񤭤ޤޤƤ¤ꡢ                   *
 *      ΥץץۤƤޤޤ                 *
 ***********************************************************************/

#include <Xm/XmAll.h>

static void OpenCB();
static void CopyCB();
static void PasteCB();
static Boolean ConvertIncProc();
static void LoseIncProc();
static void DoneIncProc();
static void CancelProc();
static void GetValueProc();

#define MAX_LEN 1024
static Widget text;
static char *string;

main(argc, argv)
    int  argc;
    char **argv;
{
    XtAppContext app_context;
    Widget toplevel, panel, field, label, fname, open, control, copy, paste;
    Arg al[20];
    int ac;

    XtSetLanguageProc(NULL, NULL, NULL);
    ac = 0;
    toplevel = XtAppInitialize(&app_context, "Selectincr", NULL, 0,
                               &argc, argv, NULL, al, ac);

    ac = 0;
    panel = XmCreateForm(toplevel, "panel", al, ac);
    XtManageChild(panel);

    /* (1) ե̾Ϥƥץ󤹤ΰ */
    ac = 0;
    field = XmCreateRowColumn(panel, "field", al, ac);
    XtManageChild(field);
    /* "ե̾: */
    ac = 0;
    label = XmCreateLabel(field, "label", al, ac);
    XtManageChild(label);
    /* ΰ */
    ac = 0;
    fname = XmCreateTextField(field, "fname", al, ac);
    XtManageChild(fname);
    /* [ץ] */
    ac = 0;
    open = XmCreatePushButton(field, "open", al, ac);
    XtAddCallback(open, XmNactivateCallback, OpenCB, fname);
    XtManageChild(open);

    /* (2) եƤɽΰ */
    ac = 0;
    text = XmCreateScrolledText(panel, "text", al, ac);
    XtManageChild(text);

    /* (3) ΰ */
    ac = 0;
    control = XmCreateRowColumn(panel, "control", al, ac);
    XtManageChild(control);
    /* [ԡ] ܥ --> ͭ: 쥯ͭ */
    ac = 0;
    copy = XmCreatePushButton(control, "copy", al, ac);
    XtAddCallback(copy, XmNactivateCallback, CopyCB, NULL);
    XtManageChild(copy);
    /* [ڡ] ܥ --> ׵: 쥯󡦥ǡ׵ */
    ac = 0;
    paste = XmCreatePushButton(control, "paste", al, ac);
    XtAddCallback(paste, XmNactivateCallback, PasteCB, NULL);
    XtManageChild(paste);

    XtVaSetValues(XtParent(text), XmNtopWidget, field,
                                  XmNbottomWidget, control, NULL);

    XtRealizeWidget(toplevel);
    XtAppMainLoop(app_context);
}

/* (4) [ץ] ܥΥХå */
static void OpenCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    Widget textf = (Widget)client_data;
    char *filename;
    FILE *fp;
    char buff[BUFSIZ];

    /* (5) Ϥ줿ե̾Ф */
    XtVaGetValues(textf, XmNvalue, &filename, NULL);

    /* (6) եƤƥȤɽ */
    if ((fp = fopen(filename, "r")) != NULL) {  /* ե򥪡ץ */
        XmTextSetString(text, "");  /* äƥȤƤõ */
        while (fgets(buff, BUFSIZ, fp) != NULL)
            XmTextInsert(text, XmTextGetLastPosition(text), buff); /* ɲ */
        fclose(fp);
    }

    XtFree(filename);
}

/* (7) ͭ: [ԡ] ܥΥХå */
static void CopyCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (8) 쥯ͭ (ХåϿ) */
    if (XtOwnSelectionIncremental(text, XA_PRIMARY,
                   XtLastTimestampProcessed(XtDisplay(text)),
                   ConvertIncProc, LoseIncProc, DoneIncProc, CancelProc, NULL))
        /* (9) ͭǤ顤ƥȤĴɽΤ餻 */
        XmTextSetHighlight(text, 0, XmTextGetLastPosition(text),
                           XmHIGHLIGHT_SELECTED);
}

/* ͭ: 쥯νͭ򼺤äȤ˸ƤӽФ */
static void LoseIncProc(w, selection, client_data)
    Widget w;
    Atom *selection;
    XtPointer client_data;
{
    /* (10) 쥯νͭԤǤʤʤä顤Ĵɽ */
    if (*selection == XA_PRIMARY)
        XmTextSetHighlight(w, 0, XmTextGetLastPosition(w), XmHIGHLIGHT_NORMAL);
}

/* (11) ׵: [ڡ] ܥΥХå */
static void PasteCB(w, client_data, call_data)
    Widget w;
    XtPointer client_data;
    XtPointer call_data;
{
    /* (12) 쥯Υǡ׵ (ǡϥХåǼ) */
    XtGetSelectionValueIncremental(text, XA_PRIMARY, XA_STRING, GetValueProc,
                              NULL, XtLastTimestampProcessed(XtDisplay(text)));
}

/* (13) ͭ: 쥯Υǡ׵ᤵ줿Ȥ˸ƤӽФ */
static Boolean ConvertIncProc(w, selection, target,
                              type_ret, val_ret, len_ret, format_ret,
                              max_len, client_data, request_id)
    Widget w;
    Atom *selection;
    Atom *target;
    Atom *type_ret;
    XtPointer *val_ret;
    unsigned long *len_ret;
    int *format_ret;
    unsigned long *max_len;
    XtPointer client_data;
    XtRequestId *request_id;
{
    static char *p;
    static Boolean start = True;
    static XtRequestId id;
    unsigned long size;

    if (*selection != XA_PRIMARY || *target != XA_STRING)
        return False;  /* ׵ᤵ줿쥯ȥפ㤦 */

    /* (14) 󥯥󥿥ž򳫻 */
    if (start) {
        p = string = XmTextGetString(w);  /* ƥȤƤФ */
        id = *request_id;  /* ׵ ID ФƤ */
        start = False;
    }

    /* (15) 󥯥󥿥žϡ̤׵դʤ */
    if (id != *request_id)
        return False;

    /* (16) žǡ֤ */
    size = strlen(p);  /* ĤΥ */
    if (size > MAX_LEN) size = MAX_LEN;    /* 1ž */
    if (size > *max_len) size = *max_len;  /* žͰ */
    *val_ret = p;           /* žǡƬݥ */
    *len_ret = size;        /* ž륵 (size = 0 žλ) */
    *type_ret = XA_STRING;  /* ϱѸΥƥȤΤ߰ */
    *format_ret = 8;        /* ʸΥեޥåȤ 8 */

    if (size == 0)  /* (17) ĤΥǡ⤦ʤ (žλ) */
        start = True;
    else
        p += size;  /* (18) žǡΰ֤ޤǿʤƤ */

    return True;   /* žǡνȤ */
}

/* (19) ׵: 쥯ΥǡäȤ˸ƤӽФ */
static void GetValueProc(w, client_data, selection, type, val, len, format)
    Widget w;
    XtPointer client_data;
    Atom *selection;
    Atom *type;
    XtPointer val;
    unsigned long *len;
    int *format;
{
    static Boolean start = True;

    if (*selection != XA_PRIMARY || *type != XA_STRING || val == NULL) {
        XBell(XtDisplay(w), 0);  /* ٥ǼԤι */
        return;
    }

    /* (20) 󥯥󥿥žδλ */
    if (*len == 0) {
        start = True;
        return;
    }

    /* (21) ǽ˥ƥȤƤ򥯥ꥢ */
    if (start) {
        XmTextSetString(w, "");
        start = False;
    }

    /* (22) äǡƥȡåȤɲ */
    XmTextInsert(text, XmTextGetLastPosition(text), (char *)val);
    XtFree((char *)val);
}

/* (23) ͭ: ׵ԤǡäǸƤӽФ */
static void DoneIncProc(w, selection, target, request_id, client_data)
    Widget w;
    Atom *selection;
    Atom *target;
    XtRequestId *request_id;
    XtPointer client_data;
{
    /* (24) žѤΥǡ */
    XtFree(string);
}

/* (25) ͭ: ǡžߤ줿Ȥ˸ƤӽФ */
static void CancelProc(w, selection, target, request_id, client_data)
    Widget w;
    Atom *selection;
    Atom *target;
    XtRequestId *request_id;
    XtPointer client_data;
{
    /* (26) žѤΥǡ */
    XtFree(string);
}
